/*
 * Copyright (C) 2004 Laszlo Pere
 * $Id: cuilexelements.h,v 1.1 2006/02/24 17:33:52 pipas Exp pipas $
 *
 * This is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: cuilexelements.h,v $
 * Revision 1.1  2006/02/24 17:33:52  pipas
 * Initial revision
 *
 */
#ifndef CUILEXELEMENTS_H
#define CUILEXELEMENTS_H

#include <gnome.h>
#include <sys/timeb.h>
#include "background.h"

typedef struct _CuiLexElement CuiLexElement;

struct _CuiLexElement {
	gchar       *text;
	GtkTextMark *begin;
	GtkTextMark *end;
	gdouble     double_val;
	gint        type;
};


void cui_lex_element_destroy(CuiLexElement *lex_element, gboolean marks);
CuiLexElement cui_lex_element_build_path(
		CuiLexElement *dir1,
		CuiLexElement *separator,
		CuiLexElement *dir2);

CuiLexElement cui_lex_element_add(
		CuiLexElement *lex1,
		CuiLexElement *lex2);

CuiLexElement *cui_lex_element_dup(CuiLexElement *lex);

#endif
