/*
 * Copyright (C) 2004 Laszlo Pere
 * $Id:$
 *
 * This is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log:$
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>
#include "cuiterminal.h"

static GtkTextViewClass *parent_class = NULL;

static void
cui_terminal_set_property(GObject *object, 
		guint           property_id, 
		const GValue    *value, 
		GParamSpec      *pspec)
{
	CuiTerminal *self = (CuiTerminal *) object;
	
	#ifdef DEBUG_WIDGETS	
	g_message("%s(): start.", __func__);
	#endif
	
	//switch(property_id){
	//	case PROPERTY_NAME:
	//		g_free(self->name);
	//		self->name = g_value_dup_string(value);
	//		break;
	//	default:
	//		G_OBJECT_WARN_INVALID_PROPERTY_ID(object, property_id, pspec);
	//}
}


static void
cui_terminal_get_property(GObject *object, 
		guint            property_id, 
		GValue           *value, 
		GParamSpec       *pspec)
{
	CuiTerminal *self = (CuiTerminal *) object;
	
	#ifdef DEBUG_WIDGETS	
	g_message("%s(): start: %d", __func__, property_id);
	#endif
	
	//switch(property_id){
	//	case PROPERTY_NAME:
	//		g_value_set_string(value, self->name);
	//		break;
	//	default:
	//		G_OBJECT_WARN_INVALID_PROPERTY_ID(object, property_id, pspec);
	//}
}

static void
cui_terminal_realize(GtkWidget *widget)
{
	GtkWidgetClass   *widget_class = GTK_WIDGET_CLASS(parent_class);
	
	g_message("%s(): start", __func__);
	widget_class->realize(widget);
}

static void
cui_terminal_size_allocate(GtkWidget *widget,
                             GtkAllocation *allocation)
{
	GtkWidgetClass   *widget_class = GTK_WIDGET_CLASS(parent_class);
	
	g_message("%s(): start", __func__);
	widget_class->size_allocate(widget, allocation);
}

static gint
cui_terminal_event(GtkWidget *widget, 
		GdkEvent *event)
{
	GtkWidgetClass   *widget_class = GTK_WIDGET_CLASS(parent_class);
	
	g_message("%s(): start", __func__);
	return widget_class->event(widget, event);
}

static gint
cui_terminal_key_press_event (GtkWidget *widget, GdkEventKey *event)
{
	GtkWidgetClass   *widget_class = GTK_WIDGET_CLASS(parent_class);
	
	g_message("%s(): start", __func__);
	return widget_class->key_press_event(widget, event);
}

static gint
cui_terminal_key_release_event (GtkWidget *widget, GdkEventKey *event)
{
	GtkWidgetClass   *widget_class = GTK_WIDGET_CLASS(parent_class);
	
	g_message("%s(): start", __func__);
	return widget_class->key_release_event(widget, event);
}

static gint
cui_terminal_button_press_event (GtkWidget *widget, GdkEventButton *event)
{
	GtkWidgetClass   *widget_class = GTK_WIDGET_CLASS(parent_class);
	
	g_message("%s(): start", __func__);
	return widget_class->button_press_event(widget, event);
}

static gint
cui_terminal_button_release_event (GtkWidget *widget, GdkEventButton *event)
{
	GtkWidgetClass   *widget_class = GTK_WIDGET_CLASS(parent_class);
	
	g_message("%s(): start", __func__);
	return widget_class->button_release_event(widget, event);
}

static gint
cui_terminal_expose_event(GtkWidget *widget, GdkEventExpose *event)
{
	GtkWidgetClass   *widget_class = GTK_WIDGET_CLASS(parent_class);
	
	g_message("%s(): start", __func__);
	return widget_class->expose_event(widget, event);
}

static gboolean
cui_terminal_focus (GtkWidget        *widget,
                     GtkDirectionType  direction)
{
	GtkWidgetClass   *widget_class = GTK_WIDGET_CLASS(parent_class);
	
	g_message("%s(): start", __func__);
	return widget_class->focus(widget, direction);
}

static gint
cui_terminal_focus_in_event (GtkWidget *widget, GdkEventFocus *event)
{
	GtkWidgetClass   *widget_class = GTK_WIDGET_CLASS(parent_class);
	
	g_message("%s(): start", __func__);
	return widget_class->focus_in_event(widget, event);
}

static gint
cui_terminal_focus_out_event (GtkWidget *widget, GdkEventFocus *event)
{
	GtkWidgetClass   *widget_class = GTK_WIDGET_CLASS(parent_class);
	
	g_message("%s(): start", __func__);
	return widget_class->focus_out_event(widget, event);
}

static gint
cui_terminal_motion_notify_event (GtkWidget *widget, GdkEventMotion *event)
{
	GtkWidgetClass   *widget_class = GTK_WIDGET_CLASS(parent_class);
	
	g_message("%s(): start", __func__);
	return widget_class->motion_notify_event(widget, event);
}

static void
cui_terminal_insert_at_cursor (GtkTextView *text_view,
                                const gchar *str)
{
	GtkTextViewClass   *text_view_class = GTK_TEXT_VIEW_CLASS(parent_class);
	
	g_message("%s(): start", __func__);
	text_view_class->insert_at_cursor(text_view, str);
}

static void
cui_terminal_delete_from_cursor (GtkTextView   *text_view,
                                  GtkDeleteType  type,
                                  gint           count)
{
	GtkTextViewClass   *text_view_class = GTK_TEXT_VIEW_CLASS(parent_class);
	
	g_message("%s(): start", __func__);
	text_view_class->delete_from_cursor(text_view, type, count);
}

static void
cui_terminal_grab_notify (GtkWidget *widget,
		 	   gboolean   was_grabbed)
{
	GtkWidgetClass   *widget_class = GTK_WIDGET_CLASS(parent_class);
	
	g_message("%s(): start", __func__);
	return widget_class->grab_notify(widget, was_grabbed);
}

static void 
cui_terminal_class_init(
		gpointer g_class, 
		gpointer g_class_data) 
{
	GObjectClass     *gobject_class = G_OBJECT_CLASS(g_class);
	GtkWidgetClass   *widget_class = GTK_WIDGET_CLASS(g_class);
	GtkTextViewClass *text_view_class = GTK_TEXT_VIEW_CLASS(g_class);
	CuiTerminalClass *klass = CUI_TERMINAL_CLASS(g_class);
	GParamSpec       *pspec;
	
	parent_class = g_type_class_peek_parent(klass);
	
	/*
	 * Wirtual methods 
	 */
	gobject_class->set_property = cui_terminal_set_property;
  	gobject_class->get_property = cui_terminal_get_property;



	
	widget_class->realize = cui_terminal_realize;
	
	widget_class->grab_notify = cui_terminal_grab_notify;
	widget_class->size_allocate = cui_terminal_size_allocate;
	widget_class->event = cui_terminal_event;
	widget_class->key_press_event = cui_terminal_key_press_event;
	widget_class->key_press_event = cui_terminal_key_release_event;
	widget_class->button_press_event = cui_terminal_button_press_event;
	widget_class->button_press_event = cui_terminal_button_release_event;
	widget_class->expose_event = cui_terminal_expose_event;

	widget_class->focus_in_event = cui_terminal_focus_in_event;
	widget_class->focus_out_event = cui_terminal_focus_out_event;
	widget_class->focus = cui_terminal_focus;
	widget_class->motion_notify_event = cui_terminal_motion_notify_event;
	
	text_view_class->insert_at_cursor = cui_terminal_insert_at_cursor;
	text_view_class->delete_from_cursor = cui_terminal_delete_from_cursor;
	

	/*
	 * Properties.
	 */
	//pspec = g_param_spec_string (
	//		"name", "name",
        //              "The name of this widget instance.",
        //              "unknown name",
        //              G_PARAM_READWRITE);
	//g_object_class_install_property(gobject_class, PROPERTY_NAME, pspec);
}


static void
cui_terminal_instance_init(
		GTypeInstance   *instance, 
		gpointer         g_class)
{
	CuiTerminal *self = (CuiTerminal *)instance;
	GtkTextView *text_view = (GtkTextView *)instance;
	CuiTerminalClass *klass = (CuiTerminalClass *)g_class;

}



GType 
cui_terminal_get_type(void) 
{
	static GType type = 0;
	
	#ifdef DEBUG_WIDGETS	
	g_message("%s(): start.", __func__);
	#endif
	
	if (type == 0) {
		static const GTypeInfo info = {
			sizeof(CuiTerminalClass),
			(GBaseInitFunc) NULL, 
			(GBaseFinalizeFunc) NULL,                  
			(GClassInitFunc) cui_terminal_class_init,   
			NULL,
			NULL,
			sizeof(CuiTerminal),
			0,
			(GInstanceInitFunc) cui_terminal_instance_init 
		};
		type = g_type_register_static(GTK_TYPE_TEXT_VIEW, 
				"CuiTerminal", &info, 0);
	}
	return type;
}


GtkWidget *
cui_terminal_new(void)
{
	CuiTerminal *terminal;
	GtkTextBuffer *text_buffer;
	
	terminal = g_object_new(CUI_TERMINAL_TYPE, NULL);
	g_object_set(G_OBJECT(terminal), 
			"editable", TRUE,
			"can-focus", TRUE,
			"has-focus", TRUE,
			"cursor-visible", TRUE,
			NULL);
	text_buffer = gtk_text_view_get_buffer(terminal);
	gtk_text_buffer_set_text(text_buffer, "initializing terminal", -1);
	return terminal;
}
