/*
 * Copyright (C) 2004 Laszlo Pere
 * $Id: dnd.h,v 1.1 2006/02/24 17:31:17 pipas Exp pipas $
 *
 * This is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: dnd.h,v $
 * Revision 1.1  2006/02/24 17:31:17  pipas
 * Initial revision
 *
 */
#ifndef DND_H
#define DND_H

#include <gnome.h>
#include "cuiterm.h"

/**
 * TargetType:
 * @TargetTextUriList:
 * @TargetFileForInode:
 * @TargetFileForMode:
 * @TargetFileForLinks:
 * @TargetUserName: 
 * @TargetGroupName:
 * @TargetFileForSize:
 * @TargetFileForDate:
 * @TargetFileForName:
 * @TargetUninitialized: the target type is not set
 */
typedef enum {
	TargetTextUriList         = 0,
	TargetFileForInode        = 1, 
	TargetFileForMode         = 2, 
	TargetFileForOwner        = 3,
	TargetFileForGroupOwner   = 4,
	TargetFileForLinks        = 5,
	TargetUserName            = 6,
	TargetGroupName           = 7,
	TargetFileForSize         = 8,
	TargetFileForDate         = 9,
	TargetFileForName         = 10,
	TargetStringOption        = 11,
	TargetStringLongOption    = 12,
	TargetStringProgram       = 13,
	TargetUninitialized       = 100
} TargetType;

void
on_main_widget_drag_data_received      (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data);

gboolean
on_main_widget_drag_motion             (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        guint            time,
                                        gpointer         user_data);
void
on_main_widget_drag_leave              (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        guint            time,
                                        gpointer         user_data);
void
on_main_widget_drag_data_get           (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data);
gboolean
on_main_widget_drag_drop               (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        guint            time,
                                        gpointer         user_data);
void
on_secondary_widget_drag_data_received (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data);

gboolean
on_secondary_widget_drag_motion        (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        guint            time,
                                        gpointer         user_data);

void
on_secondary_widget_drag_leave         (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        guint            time,
                                        gpointer         user_data);

void
on_secondary_widget_drag_data_get      (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data);

gboolean
on_secondary_widget_drag_drop          (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        guint            time,
                                        gpointer         user_data);

gint dnd_init_destination(GtkWidget *widget);
gint dnd_drag_begin(GdkEventMotion *event, gint button, GtkWidget *widget);
GtkTargetList *dnd_get_file_target_list(void);
GtkTargetList *dnd_get_dir_target_list(void);
#endif
