/*
 * Copyright (C) 2004 Laszlo Pere
 * $Id: icons.h,v 1.1 2006/02/24 17:30:17 pipas Exp pipas $
 *
 * This is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: icons.h,v $
 * Revision 1.1  2006/02/24 17:30:17  pipas
 * Initial revision
 *
 */
#ifndef ICONS_H
#define ICONS_H


#include "cuiterm.h"
#include "filename.h" 

#define CUI_ICON_TYPE (cui_icon_get_type())
#define CUI_ICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), \
			 CUI_ICON_TYPE, CuiIcon))
#define CUI_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), \
			CUI_ICON_TYPE, CuiIconClass))
#define CUI_IS_ICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj), \
			CUI_ICON_TYPE))
#define CUI_IS_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), \
			CUI_ICON_TYPE))
#define CUI_ICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), \
			CUI_ICON_TYPE, CuiIconClass))

/**
 * CuiIcon:
 * @pixbuf: the GdkPixbuf we use as an icon
 *
 */
typedef struct _CuiIcon CuiIcon;
struct _CuiIcon {
	/*< private >*/
	GObject parent;
	/*< public >*/
	GdkPixbuf             *pixbuf;
	gint                   max_size;
	gint                   max_height;
	CuiFilename           *filename;
};

typedef struct _CuiIconClass CuiIconClass;
struct _CuiIconClass {
	/*< private >*/
	GObjectClass           parent_class;
	GtkIconTheme          *icon_theme;
	/*< public >*/
};

GType cui_icon_get_type(void);
CuiIcon *cui_icon_new(CuiFilename *file);
GdkPixbuf *cui_icon_get_pixbuf(CuiIcon *icon);

#endif
