/* A Bison parser, made by GNU Bison 2.1.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse ls_parse
#define yylex   ls_lex
#define yyerror ls_error
#define yylval  ls_lval
#define yychar  ls_char
#define yydebug ls_debug
#define yynerrs ls_nerrs


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     STRING = 258,
     DIRNAME = 259,
     FILENAME = 260,
     LINKNAME = 261,
     L_TOTAL = 262,
     L_MODE = 263,
     L_NUMBER = 264,
     L_DNUMBERS = 265,
     L_STRING = 266,
     L_TIMESTAMP = 267,
     L_ARROW = 268,
     ERROR_MESSAGE = 269,
     END_OF_WINDOW = 270
   };
#endif
/* Tokens.  */
#define STRING 258
#define DIRNAME 259
#define FILENAME 260
#define LINKNAME 261
#define L_TOTAL 262
#define L_MODE 263
#define L_NUMBER 264
#define L_DNUMBERS 265
#define L_STRING 266
#define L_TIMESTAMP 267
#define L_ARROW 268
#define ERROR_MESSAGE 269
#define END_OF_WINDOW 270




/* Copy the first part of user declarations.  */
#line 1 "ls_parser.y"

/*
 * Copyright (C) 2004 Laszlo Pere
 * $Id: ls_parser.y,v 1.1 2006/02/24 08:19:15 pipas Exp pipas $
 *
 * This is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: ls_parser.y,v $
 * Revision 1.1  2006/02/24 08:19:15  pipas
 * Initial revision
 *
 */
#include <gnome.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

#include "ls_parser_c.h"
#include "cuiterm.h"
#include "terminal.h"
#include "cuiwindow.h"
#include "ls_parser.h"
#include "filename.h"
#include "dnd.h"
extern CuiWindow *window_for_lex;

typedef enum {
	UsualLine,
	DeviceLine
} LineType;

/*
 * We use this structure to store all the lines we process, so we can go back
 * when all of the lines are well known;
 */
typedef struct one_line {
	CuiLexElement *mode;       /* the mode string */
	CuiLexElement *lnumber;    /* link number */
	CuiLexElement *uname;      /* the owner */
	CuiLexElement *gname;
	CuiLexElement *size; 
	CuiLexElement *timestamp;
	CuiLexElement *filename;
	CuiLexElement *origin;  /* target if the entry is a link */
	LineType       line_type;
} one_line;


static GList *list = NULL; /* The list we store the long lines */

/**
 * Frees the allocated resources and resets the parser.
 */
static inline void
finalize_parser(void)
{
	GList *l;
	one_line *line;
	/*
	 * Destroying the list. This will not destroy only the few elements we 
	 * left in the list after the last filename has been processed.
	 */
	l = list;
	while (l != NULL){
		line = l->data;
		cui_lex_element_destroy(line->mode, TRUE); 
		g_free(line->mode);
		
		cui_lex_element_destroy(line->lnumber, TRUE); 
		g_free(line->lnumber);
		
		cui_lex_element_destroy(line->uname, TRUE); 
		g_free(line->uname);
		
		cui_lex_element_destroy(line->gname, TRUE); 
		g_free(line->gname);
		
		cui_lex_element_destroy(line->size, TRUE); 
		g_free(line->size);
		
		cui_lex_element_destroy(line->timestamp, TRUE); 
		g_free(line->timestamp);
		
		cui_lex_element_destroy(line->filename, TRUE); 
		g_free(line->filename);

		if (line->origin != NULL)
			cui_lex_element_destroy(line->origin, TRUE);
		g_free(line->origin);

		l = l->next;
	}
	g_list_free(list);
	list = NULL;
}

static inline void 
append_long_line(CuiLexElement *mode,
	CuiLexElement *lnumber,
	CuiLexElement *uname,
	CuiLexElement *gname,
	CuiLexElement *size,
	CuiLexElement *timestamp,
	CuiLexElement *filename,
	CuiLexElement *origin,
	LineType       type)
{
	one_line *new_line = g_new(one_line, 1);
	new_line->mode      = g_memdup(mode, sizeof(CuiLexElement));	
	new_line->lnumber   = g_memdup(lnumber, sizeof(CuiLexElement));	
	new_line->uname     = g_memdup(uname, sizeof(CuiLexElement));	
	new_line->gname     = g_memdup(gname, sizeof(CuiLexElement));	
	new_line->size      = g_memdup(size, sizeof(CuiLexElement));	
	new_line->timestamp = g_memdup(timestamp, sizeof(CuiLexElement));	
	new_line->filename  = g_memdup(filename, sizeof(CuiLexElement));
	if (origin != NULL)
		new_line->origin  = g_memdup(origin, sizeof(CuiLexElement));
	else
		new_line->origin  = NULL;
	new_line->line_type = type;

	list = g_list_append(list, new_line);
}

static inline gdouble 
sum_long_lines(void)
{
	GList *le;
	one_line *line;
	gdouble retval = 0;

	le = list;
	while (le != NULL){
		line = le->data;
		if (line->line_type != DeviceLine)
			retval += line->size->double_val;
		le = le->next;
	}
	return retval;
}

#undef PROFILE

#ifdef PROFILE
#   include <time.h>
#endif

static inline void
process_long_lines(CuiWindow *window)
{
	GList *le;
	one_line *line;
	gdouble full_size = sum_long_lines();
	CuiFilename *fn;
	CuiWidget *widget;
	Background *background;
	CuiFileSizeChange change;
#ifdef PROFILE
	clock_t start_time, end_time;
#endif

	g_return_if_fail(CUI_IS_WINDOW(window));
	background = cui_widget_get_background(CUI_WIDGET(window));
	/*
	 * We go through the lines and create the widgets.
	 */
	le = list;
	//g_message("%s(): length of list: %d", __func__, g_list_length(list));
	while (le != NULL){
		line = le->data;
		/* 
		 * Filename, stores information about the file.
		 */
#ifdef PROFILE
			start_time = clock();
#endif
		fn = cui_filename_new(line->filename->text, window->wd->str); 
#ifdef PROFILE
			end_time = clock();
			g_message("%s(): Parsing time: %.12f\n", 
					__func__,
					((double)(end_time-start_time))/CLOCKS_PER_SEC);
#endif
		cui_filename_set_mode_string(fn, line->mode->text);
		cui_filename_set_owner_and_group(fn, 
			line->uname->text, 
			line->gname->text);
		/*
		 * Link action area.
		 */
		cui_action_area_new_for_link(window, background,
			fn,
			line->lnumber->begin,
			line->lnumber->end);
		/*
		 * Filename action area.
		 */
		cui_action_area_new_for_filename(
			window,
			background, 
			fn,
			line->filename->begin, 
			line->filename->end);
		/*
		 * Filename menu.
		 */
	   	cui_file_menu_new_for_filename(window, background, fn,
	   		line->filename->begin, 
			line->filename->end);
		/*
		 * Mode action area, and dnd source.
		 */
		cui_action_area_new_for_mode(window, background, 
			fn, 
	   		line->mode->begin, 
			line->mode->end);
		cui_dnd_source_new_with_file(window, background, TargetFileForMode, 
			fn, line->mode->begin, line->mode->end);
		/*
		 * Size, or device number action areas.
		 */
		if (line->line_type != DeviceLine){
			cui_action_area_new_for_size(window, background, 
				fn, 
	  	 		line->size->begin, 
				line->size->end);
		} else {
			cui_action_area_new_for_node_numbers(window, background,
				fn,
					line->size->begin,
				line->size->end);
		}
		/*
		 * Date timestamp action area.
		 */
		cui_action_area_new_for_moddate(window, background,
			fn,
			line->timestamp->begin,
			line->timestamp->end);
	   	/* 
		 * User menu and owner dnd source
		 */
		cui_action_area_new_for_owner(window, background,
			fn,
			line->uname->begin,
			line->uname->end);
	   	widget = cui_user_menu_new(line->uname->text);
	   	cui_widget_set_background(widget, background);
	   	cui_widget_set_area_by_marks(widget, 
			line->uname->begin, 
			line->uname->end);
	   	/*
		 * Filename entry. 
		 */
	   	cui_entry_new_for_filename(window, background, fn, 
	   		line->filename->begin, 
			line->filename->end, 
			line->filename->text);
	   	/* 
		 * Timestamp entry. 
		 */
	   	widget = cui_entry_new();
	   	cui_widget_set_background(widget, background);
	   	cui_widget_set_area_by_marks(widget, 
			line->timestamp->begin, 
			line->timestamp->end);
	   	cui_entry_set_default_text(CUI_ENTRY(widget), 
			line->timestamp->text);
	   	/* 
		 * Owner entry.
		 */
	   	widget = cui_entry_new();
	   	cui_widget_set_background(widget, background);
	   	cui_widget_set_area_by_marks(widget, line->uname->begin, line->uname->end);
	   	cui_entry_set_default_text(CUI_ENTRY(widget), line->uname->text);
	   	cui_widget_append_file_command(widget, FileChangeOwner, fn);
		cui_widget_append_window_command(widget, WindowRefresh, window);
		cui_action_area_new_for_group(window, background,
			fn,
			line->gname->begin,
			line->gname->end);
		cui_dnd_source_new_with_file(window, background, TargetFileForOwner, fn,
			line->uname->begin,
			line->gname->end);
	
	

	   	/*
		 * Group entry and dnd source
		 */
	   	widget = cui_entry_new();
	   	cui_widget_set_background(widget, background);
	   	cui_widget_set_area_by_marks(widget, line->gname->begin, line->gname->end);
	   	cui_entry_set_default_text(CUI_ENTRY(widget), line->gname->text);
	   	cui_widget_append_file_command(widget, FileChangeGroup, fn);
		cui_widget_append_window_command(widget, WindowRefresh, window);
		cui_dnd_source_new_with_file(window, background, TargetFileForGroupOwner, fn,
			line->gname->begin,
			line->gname->end);
	   	/* 
		 * Mode menu.
		 */
	   	widget = cui_mode_menu_new();
	   	cui_widget_set_background(widget, background);
	   	cui_widget_set_area_by_marks(widget, 
			line->mode->begin, 
			line->mode->end);
	   	cui_mode_menu_set_filename(CUI_MODE_MENU(widget), fn);
		cui_widget_append_window_command(widget, WindowRefresh, window);
		/* 
		 * Colored sizebar. 
		 */
		if (line->line_type != DeviceLine){
			widget = cui_size_bar_new();
	 		cui_widget_set_background(widget, background);
	   		cui_widget_set_area_by_marks(widget, line->mode->begin, line->mode->end);
			
	   		g_object_set(G_OBJECT(widget), 
				"percent", line->size->double_val / full_size,
				NULL);
				
			// FIXME: we should differentiate between the exact size and the human readable format.
			cui_filename_set_file_size(fn, (gint64)line->size->double_val);
	 		change = cui_filename_get_size_change(fn);
			if (change == FileSizeIncreasing)
				g_object_set(G_OBJECT(widget),
			   		"decoration", DecorIncrease,
					NULL);
			if (change == FileSizeDecreasing)
				g_object_set(G_OBJECT(widget),
		   			"decoration", DecorDecrease,
					NULL);
		}

		/********************************************************
		 * Drag&Drop target area.                               *
		 ********************************************************/
		GtkTargetList *tlist;
		widget = cui_rectangle_new();
	   	cui_widget_set_background(widget, background);
	   	cui_widget_set_area_by_marks(widget, 
			line->mode->begin, 
			line->filename->end);
		cui_widget_set_width_by_percent(widget, 1.00);
		if (cui_filename_is_dir(fn))
			tlist = dnd_get_dir_target_list();
		else
			tlist = dnd_get_file_target_list();
		cui_rectangle_set_target_list(CUI_RECTANGLE(widget), tlist);
		cui_rectangle_set_target_object(CUI_RECTANGLE(widget), 
			G_OBJECT(fn));
		cui_rectangle_set_is_dnd_target(CUI_RECTANGLE(widget), TRUE);
	        cui_widget_append_window_command(widget, WindowRefresh, window);
		
		/*
		 * DnD source for filename.
		 */
		cui_dnd_source_new_with_file(window, background, TargetFileForName, fn,
			line->filename->begin,
			line->filename->end);

		
		if (line->origin != NULL){
			/* 
			 * Filename becomes origin of the link.
			 */
			fn = cui_filename_new(line->origin->text, window->wd->str); 
			/*
			 * Filename action area for the origin.
			 */
			cui_action_area_new_for_filename(
				window,
				background, 
				fn,
				line->origin->begin, 
				line->origin->end);
			/*
			 * Filename menu for the origin.
			 */
			cui_file_menu_new_for_filename(window, background, fn,
				line->origin->begin, 
				line->origin->end);
			/* 
			 * Filename syntax highlight for the origin. 
			 */
			cui_syntax_highlight_apply_filename(background,
				fn,
				line->origin->begin,
				line->origin->end);
			/********************************************************
			 * Drag&Drop target and source area.                    *
			 ********************************************************/
			GtkTargetList *tlist;
			widget = cui_rectangle_new();
			cui_widget_set_background(widget, background);
			cui_widget_set_area_by_marks(widget, 
				line->origin->begin, 
				line->origin->end);
			cui_widget_set_width_by_percent(widget, 1.00);
			if (cui_filename_is_dir(fn))
				tlist = dnd_get_dir_target_list();
			else
				tlist = dnd_get_file_target_list();
			cui_rectangle_set_target_list(CUI_RECTANGLE(widget), tlist);
			cui_rectangle_set_target_object(CUI_RECTANGLE(widget), 
				G_OBJECT(fn));
			cui_rectangle_set_is_dnd_target(CUI_RECTANGLE(widget), TRUE);
			cui_widget_append_window_command(widget, WindowRefresh, window);

			/* DnD source for filename */	
			widget = cui_rectangle_new();
			cui_widget_set_background(widget, background);
			cui_widget_set_area_by_marks(widget, 
			line->filename->begin, 
			line->filename->end);
			cui_rectangle_set_dnd_source_data(CUI_RECTANGLE(widget),
			TargetFileForName, fn, sizeof(CuiFilename));
			cui_rectangle_set_is_dnd_source(CUI_RECTANGLE(widget), TRUE);
		}
next_line:
		le = le->next;
	}
}



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 441 "ls_parser.y"
typedef union YYSTYPE { 
	CuiLexElement sval;
	Direntry      eval;	
} YYSTYPE;
/* Line 196 of yacc.c.  */
#line 567 "ls_parser.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 219 of yacc.c.  */
#line 579 "ls_parser.c"

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T) && (defined (__STDC__) || defined (__cplusplus))
# include <stddef.h> /* INFRINGES ON USER NAME SPACE */
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if defined (__STDC__) || defined (__cplusplus)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     define YYINCLUDED_STDLIB_H
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2005 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM ((YYSIZE_T) -1)
#  endif
#  ifdef __cplusplus
extern "C" {
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if (! defined (malloc) && ! defined (YYINCLUDED_STDLIB_H) \
	&& (defined (__STDC__) || defined (__cplusplus)))
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if (! defined (free) && ! defined (YYINCLUDED_STDLIB_H) \
	&& (defined (__STDC__) || defined (__cplusplus)))
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifdef __cplusplus
}
#  endif
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE))			\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  16
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   38

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  16
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  8
/* YYNRULES -- Number of rules. */
#define YYNRULES  22
/* YYNRULES -- Number of states. */
#define YYNSTATES  33

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   270

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned char yyprhs[] =
{
       0,     0,     3,     6,     8,    10,    12,    14,    16,    18,
      20,    28,    38,    46,    48,    50,    52,    54,    56,    59,
      61,    63,    65
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      17,     0,    -1,    17,    18,    -1,    18,    -1,    22,    -1,
      19,    -1,    14,    -1,    15,    -1,     1,    -1,     7,    -1,
       8,     9,    20,    21,     9,    12,    11,    -1,     8,     9,
      20,    21,     9,    12,    11,    13,    11,    -1,     8,     9,
      20,    21,    10,    12,    11,    -1,    11,    -1,     9,    -1,
      11,    -1,     9,    -1,    23,    -1,    22,    23,    -1,     3,
      -1,     4,    -1,     5,    -1,     6,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,   458,   458,   459,   462,   463,   464,   468,   483,   486,
     487,   490,   493,   498,   499,   502,   503,   506,   507,   510,
     531,   554,   576
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "STRING", "DIRNAME", "FILENAME",
  "LINKNAME", "L_TOTAL", "L_MODE", "L_NUMBER", "L_DNUMBERS", "L_STRING",
  "L_TIMESTAMP", "L_ARROW", "ERROR_MESSAGE", "END_OF_WINDOW", "$accept",
  "lines", "line", "longline", "uname", "gname", "shortline", "filename", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    16,    17,    17,    18,    18,    18,    18,    18,    19,
      19,    19,    19,    20,    20,    21,    21,    22,    22,    23,
      23,    23,    23
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       7,     9,     7,     1,     1,     1,     1,     1,     2,     1,
       1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     8,    19,    20,    21,    22,     9,     0,     6,     7,
       0,     3,     5,     4,    17,     0,     1,     2,    18,    14,
      13,     0,    16,    15,     0,     0,     0,     0,     0,    10,
      12,     0,    11
};

/* YYDEFGOTO[NTERM-NUM]. */
static const yysigned_char yydefgoto[] =
{
      -1,    10,    11,    12,    21,    24,    13,    14
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -8
static const yysigned_char yypact[] =
{
      15,    -8,    -8,    -8,    -8,    -8,    -8,    -7,    -8,    -8,
       0,    -8,    -8,     6,    -8,    16,    -8,    -8,    -8,    -8,
      -8,    17,    -8,    -8,    22,     1,     5,    13,    23,    20,
      -8,    24,    -8
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
      -8,    -8,    26,    -8,    -8,    -8,    -8,    25
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned char yytable[] =
{
      16,     1,    15,     2,     3,     4,     5,     6,     7,     2,
       3,     4,     5,    27,     8,     9,     1,    28,     2,     3,
       4,     5,     6,     7,    29,    19,    22,    20,    23,     8,
       9,    25,    26,    31,    30,    32,    17,     0,    18
};

static const yysigned_char yycheck[] =
{
       0,     1,     9,     3,     4,     5,     6,     7,     8,     3,
       4,     5,     6,    12,    14,    15,     1,    12,     3,     4,
       5,     6,     7,     8,    11,     9,     9,    11,    11,    14,
      15,     9,    10,    13,    11,    11,    10,    -1,    13
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     1,     3,     4,     5,     6,     7,     8,    14,    15,
      17,    18,    19,    22,    23,     9,     0,    18,    23,     9,
      11,    20,     9,    11,    21,     9,    10,    12,    12,    11,
      11,    13,    11
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (window, YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (0)


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (N)								\
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (0)
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
              (Loc).first_line, (Loc).first_column,	\
              (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr,					\
                  Type, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname[yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      size_t yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

#endif /* YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);


# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (CuiWindow *window);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (CuiWindow *window)
#else
int
yyparse (window)
    CuiWindow *window;
#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a look-ahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to look-ahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 458 "ls_parser.y"
    { /*g_message("%s(): lines line", __func__); */}
    break;

  case 3:
#line 459 "ls_parser.y"
    { /*g_message("%s(): lines line", __func__); */}
    break;

  case 6:
#line 464 "ls_parser.y"
    { 
    		ls_place_error_message(window, (yyvsp[0].sval).text, (yyvsp[0].sval).begin, (yyvsp[0].sval).end); 
		window->error_code++;
	}
    break;

  case 7:
#line 468 "ls_parser.y"
    {
		Background *bg;
		if (list != NULL){
			process_long_lines(window_for_lex);
			finalize_parser();
			bg = cui_widget_get_background(CUI_WIDGET(window));
			if (background_check_stored_command(bg, CommandNewFile) ||
					background_check_stored_command(bg, CommandNewDirectory)){
						if (background_get_stored_widget(bg) != NULL)
							cui_entry_realize(CUI_ENTRY(background_get_stored_widget(bg)));
						background_store_command(bg, CommandNone);
					}
		}
		return 0;
	}
    break;

  case 8:
#line 483 "ls_parser.y"
    { window->error_code++; }
    break;

  case 10:
#line 487 "ls_parser.y"
    {
				append_long_line(&(yyvsp[-6].sval), &(yyvsp[-5].sval), &(yyvsp[-4].sval), &(yyvsp[-3].sval), &(yyvsp[-2].sval), &(yyvsp[-1].sval), &(yyvsp[0].sval), NULL, UsualLine);
		}
    break;

  case 11:
#line 490 "ls_parser.y"
    {
				append_long_line(&(yyvsp[-8].sval), &(yyvsp[-7].sval), &(yyvsp[-6].sval), &(yyvsp[-5].sval), &(yyvsp[-4].sval), &(yyvsp[-3].sval), &(yyvsp[-2].sval), &(yyvsp[0].sval), UsualLine);
		}
    break;

  case 12:
#line 493 "ls_parser.y"
    {
				append_long_line(&(yyvsp[-6].sval), &(yyvsp[-5].sval), &(yyvsp[-4].sval), &(yyvsp[-3].sval), &(yyvsp[-2].sval), &(yyvsp[-1].sval), &(yyvsp[0].sval), NULL, DeviceLine);
		}
    break;

  case 13:
#line 498 "ls_parser.y"
    { (yyval.sval) = (yyvsp[0].sval); }
    break;

  case 14:
#line 499 "ls_parser.y"
    { (yyval.sval) = (yyvsp[0].sval); g_warning("UID for username."); }
    break;

  case 15:
#line 502 "ls_parser.y"
    { (yyval.sval) = (yyvsp[0].sval); }
    break;

  case 16:
#line 503 "ls_parser.y"
    { (yyval.sval) = (yyvsp[0].sval); g_warning("GID for username."); }
    break;

  case 17:
#line 506 "ls_parser.y"
    { }
    break;

  case 18:
#line 507 "ls_parser.y"
    { }
    break;

  case 19:
#line 510 "ls_parser.y"
    {  
			CuiFilename *fn;
			Background *background;
			background =
				cui_widget_get_background(CUI_WIDGET(window));
		   	fn = cui_filename_new((yyvsp[0].sval).text, window->wd->str); 
	   		/* Action area */
			cui_action_area_new_for_filename(window, background, 
				fn, (yyvsp[0].sval).begin, (yyvsp[0].sval).end);
			/* File menu */
		   	cui_file_menu_new_for_filename(window, background, 
				fn, (yyvsp[0].sval).begin, (yyvsp[0].sval).end);
	   		/* Filename entry */
			cui_entry_new_for_filename(window, background, 
				fn, (yyvsp[0].sval).begin, (yyvsp[0].sval).end, (yyvsp[0].sval).text);
	   		/* Filename syntax highlight */
			cui_syntax_highlight_apply_filename(background,
	   			fn,
				(yyvsp[0].sval).begin,
				(yyvsp[0].sval).end);
			}
    break;

  case 20:
#line 531 "ls_parser.y"
    {
			CuiFilename *fn;
			Background *background;
			background =
				cui_widget_get_background(CUI_WIDGET(window));
		   	fn = cui_filename_new((yyvsp[0].sval).text, window->wd->str); 
			cui_filename_set_filetype_dir(fn);
	   		/* Action area */
	   		cui_action_area_new_for_filename(
				window, background, 
				fn, (yyvsp[0].sval).begin, (yyvsp[0].sval).end);
			/* File menu */
		   	cui_file_menu_new_for_filename(window, background, 
				fn, (yyvsp[0].sval).begin, (yyvsp[0].sval).end);
	   		/* Filename entry */
			cui_entry_new_for_filename(window, background, 
				fn, (yyvsp[0].sval).begin, (yyvsp[0].sval).end, (yyvsp[0].sval).text);
	   		/* Filename syntax highlight */
			cui_syntax_highlight_apply_filename(background,
	   			fn,
				(yyvsp[0].sval).begin,
				(yyvsp[0].sval).end);
			}
    break;

  case 21:
#line 554 "ls_parser.y"
    {
			CuiFilename *fn;
			Background *background;
			background =
				cui_widget_get_background(CUI_WIDGET(window));
		   	fn = cui_filename_new((yyvsp[0].sval).text, window->wd->str); 
			cui_filename_set_filetype_regular(fn);
	   		/* Action area */
	   		cui_action_area_new_for_filename( window, background, 
				fn, (yyvsp[0].sval).begin, (yyvsp[0].sval).end);
			/* File menu */
		   	cui_file_menu_new_for_filename(window, background, 
				fn, (yyvsp[0].sval).begin, (yyvsp[0].sval).end);
	   		/* Filename entry */
			cui_entry_new_for_filename(window, background, 
				fn, (yyvsp[0].sval).begin, (yyvsp[0].sval).end, (yyvsp[0].sval).text);
	   		/* Filename syntax highlight */
			cui_syntax_highlight_apply_filename(background,
	   			fn,
				(yyvsp[0].sval).begin,
				(yyvsp[0].sval).end);
			}
    break;

  case 22:
#line 576 "ls_parser.y"
    {
			CuiFilename *fn;
			Background *background;
			background =
				cui_widget_get_background(CUI_WIDGET(window));
		   	fn = cui_filename_new((yyvsp[0].sval).text, window->wd->str); 
			cui_filename_set_filetype_link(fn);
	   		/* Action area */
	   		cui_action_area_new_for_filename(window, background, 
				fn, (yyvsp[0].sval).begin, (yyvsp[0].sval).end);
			/* File menu */
		   	cui_file_menu_new_for_filename(window, background, 
				fn, (yyvsp[0].sval).begin, (yyvsp[0].sval).end);
	   		/* Filename entry */
			cui_entry_new_for_filename(window, background, 
				fn, (yyvsp[0].sval).begin, (yyvsp[0].sval).end, (yyvsp[0].sval).text);
	   		/* Filename syntax highlight */
			cui_syntax_highlight_apply_filename(background,
	   			fn,
				(yyvsp[0].sval).begin,
				(yyvsp[0].sval).end);
			}
    break;


      default: break;
    }

/* Line 1126 of yacc.c.  */
#line 1783 "ls_parser.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  int yytype = YYTRANSLATE (yychar);
	  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
	  YYSIZE_T yysize = yysize0;
	  YYSIZE_T yysize1;
	  int yysize_overflow = 0;
	  char *yymsg = 0;
#	  define YYERROR_VERBOSE_ARGS_MAXIMUM 5
	  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
	  int yyx;

#if 0
	  /* This is so xgettext sees the translatable formats that are
	     constructed on the fly.  */
	  YY_("syntax error, unexpected %s");
	  YY_("syntax error, unexpected %s, expecting %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s or %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
#endif
	  char *yyfmt;
	  char const *yyf;
	  static char const yyunexpected[] = "syntax error, unexpected %s";
	  static char const yyexpecting[] = ", expecting %s";
	  static char const yyor[] = " or %s";
	  char yyformat[sizeof yyunexpected
			+ sizeof yyexpecting - 1
			+ ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
			   * (sizeof yyor - 1))];
	  char const *yyprefix = yyexpecting;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 1;

	  yyarg[0] = yytname[yytype];
	  yyfmt = yystpcpy (yyformat, yyunexpected);

	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
		  {
		    yycount = 1;
		    yysize = yysize0;
		    yyformat[sizeof yyunexpected - 1] = '\0';
		    break;
		  }
		yyarg[yycount++] = yytname[yyx];
		yysize1 = yysize + yytnamerr (0, yytname[yyx]);
		yysize_overflow |= yysize1 < yysize;
		yysize = yysize1;
		yyfmt = yystpcpy (yyfmt, yyprefix);
		yyprefix = yyor;
	      }

	  yyf = YY_(yyformat);
	  yysize1 = yysize + yystrlen (yyf);
	  yysize_overflow |= yysize1 < yysize;
	  yysize = yysize1;

	  if (!yysize_overflow && yysize <= YYSTACK_ALLOC_MAXIMUM)
	    yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg)
	    {
	      /* Avoid sprintf, as that infringes on the user's name space.
		 Don't have undefined behavior even if the translation
		 produced a string with the wrong number of "%s"s.  */
	      char *yyp = yymsg;
	      int yyi = 0;
	      while ((*yyp = *yyf))
		{
		  if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		    {
		      yyp += yytnamerr (yyp, yyarg[yyi++]);
		      yyf += 2;
		    }
		  else
		    {
		      yyp++;
		      yyf++;
		    }
		}
	      yyerror (window, yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    {
	      yyerror (window, YY_("syntax error"));
	      goto yyexhaustedlab;
	    }
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror (window, YY_("syntax error"));
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
        }
      else
	{
	  yydestruct ("Error: discarding", yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (0)
     goto yyerrorlab;

yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping", yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token. */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (window, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK;
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 599 "ls_parser.y"


extern int ls_lineno;

int ls_error(CuiWindow *window, char *c )
{
	gchar *error_message;
	
	error_message = g_strdup_printf(
		"Directory Contents Error: %s in line %d", 
		c,
		ls_lineno);
	g_warning(error_message);
	cui_window_set_title(window, error_message);
	g_free(error_message);
	return 1;
}

int ls_wrap(void)
{
	return 1;
}

