%{
/*
 * Copyright (C) 2004 Laszlo Pere
 * $Id: w_parser.y,v 1.1 2006/02/24 08:18:18 pipas Exp pipas $
 *
 * This is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Library General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: w_parser.y,v $
 * Revision 1.1  2006/02/24 08:18:18  pipas
 * Initial revision
 *
 */
#include <gnome.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

#include "cuiterm.h"
#include "cuilexelements.h"
#include "w_parser.h"
#include "terminal.h"
#include "background.h"
#include "cuiwindow.h"

extern CuiWindow *window_for_lex;
extern int w_lexer_program;

%}

%debug
%parse-param {CuiWindow *window}
%union { 
	CuiLexElement sval;
}
 
%token <sval> UPTIME HEADER
%token <sval> NAME LINE FROM COMMENT
%token <sval> MONTH DATE TIME 
%token <sval> XDM INTERVAL
%token <sval> PROGRAM
%type  <sval> idle jcpu pcpu

%%
lines: lines line
     | line
     ;

line: UPTIME { cui_lex_element_destroy(&$1, TRUE); }
    | HEADER { cui_lex_element_destroy(&$1, TRUE); }
    | NAME LINE FROM datetime idle jcpu pcpu 
              {
	        w_lexer_program = 1;
	      }
      PROGRAM {
    		cui_widgets_new_for_filename(window, &$1);
		cui_lex_element_destroy(&$1, TRUE);
		cui_lex_element_destroy(&$2, TRUE);
		cui_lex_element_destroy(&$3, TRUE);
		cui_lex_element_destroy(&$9, TRUE);
    	}
    | error { window->error_code++; }
    ;

datetime
  : DATE        { cui_lex_element_destroy(&$1, TRUE); }
  | TIME        { cui_lex_element_destroy(&$1, TRUE); }
  ;

idle
  : XDM         { cui_lex_element_destroy(&$1, TRUE); }
  | TIME        { cui_lex_element_destroy(&$1, TRUE); }
  | INTERVAL    { cui_lex_element_destroy(&$1, TRUE); }
  ;

jcpu
  : XDM         { cui_lex_element_destroy(&$1, TRUE); }
  | TIME        { cui_lex_element_destroy(&$1, TRUE); }
  | INTERVAL    { cui_lex_element_destroy(&$1, TRUE); }
  ;

pcpu
  : XDM         { cui_lex_element_destroy(&$1, TRUE); }
  | TIME        { cui_lex_element_destroy(&$1, TRUE); }
  | INTERVAL    { cui_lex_element_destroy(&$1, TRUE); }
  ;
%%

extern int w_lineno;

int w_error(CuiWindow *window, char *c )
{
	gchar *error_message;
	error_message = g_strdup_printf(
		"Logged on Users error: %s in lineno %d",
		c,
		w_lineno);
	g_warning(error_message);
	cui_window_set_title(window, error_message);
	g_free(error_message);
	return(1);
}

int w_wrap(void)
{
	//g_message("%s(): returning 1", __func__);
	return 1;
}
